"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _awsSdk = _interopRequireDefault(require("aws-sdk"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _mimeTypes = _interopRequireDefault(require("mime-types"));

var SpacesClient =
/*#__PURE__*/
function () {
  function SpacesClient(endpoint, bucket) {
    var accessKeyId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var secretAccessKey = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    (0, _classCallCheck2["default"])(this, SpacesClient);
    this.endpoint = endpoint;
    this.bucket = bucket;
    var options = {
      endpoint: endpoint
    };

    if (accessKeyId) {
      options.accessKeyId = accessKeyId;
    }

    if (secretAccessKey) {
      options.secretAccessKey = secretAccessKey;
    }

    this.s3client = new _awsSdk["default"].S3(options);
  }

  (0, _createClass2["default"])(SpacesClient, [{
    key: "getURL",
    value: function getURL(path) {
      return "https://".concat(this.bucket, ".").concat(this.endpoint, "/").concat(path);
    }
  }, {
    key: "getCDNURL",
    value: function getCDNURL(path) {
      var url = this.getURL(path);
      return url.replace(/digitaloceanspaces/, 'cdn.digitaloceanspaces');
    }
  }, {
    key: "uploadFile",
    value: function () {
      var _uploadFile = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(uploadFilePath, destinationPath) {
        var permission,
            _args = arguments;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                permission = _args.length > 2 && _args[2] !== undefined ? _args[2] : 'private';
                _context.next = 3;
                return this.s3client.upload({
                  Bucket: this.bucket,
                  Body: _fs["default"].createReadStream(uploadFilePath),
                  Key: destinationPath,
                  ACL: permission === 'public' ? 'public-read' : permission,
                  // ContentDisposition: 'attachment',
                  ContentType: _mimeTypes["default"].lookup(uploadFilePath)
                }).promise();

              case 3:
                return _context.abrupt("return", this.getCDNURL(destinationPath));

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function uploadFile(_x, _x2) {
        return _uploadFile.apply(this, arguments);
      }

      return uploadFile;
    }()
  }, {
    key: "listPathObjects",
    value: function () {
      var _listPathObjects = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2(path) {
        var data;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.s3client.listObjectsV2({
                  Bucket: this.bucket,
                  Prefix: path
                }).promise();

              case 2:
                data = _context2.sent;
                return _context2.abrupt("return", data.Contents);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function listPathObjects(_x3) {
        return _listPathObjects.apply(this, arguments);
      }

      return listPathObjects;
    }()
  }, {
    key: "listPathFiles",
    value: function () {
      var _listPathFiles = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee3(path) {
        var _this = this;

        var objects;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.listPathObjects(path);

              case 2:
                objects = _context3.sent;
                return _context3.abrupt("return", objects.map(function (_ref) {
                  var Key = _ref.Key;
                  return _this.getCDNURL(Key);
                }));

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function listPathFiles(_x4) {
        return _listPathFiles.apply(this, arguments);
      }

      return listPathFiles;
    }()
  }, {
    key: "deleteObjects",
    value: function () {
      var _deleteObjects = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee4(objects) {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt("return", this.s3client.deleteObjects({
                  Bucket: this.bucket,
                  Delete: {
                    Objects: objects.map(function (object) {
                      return {
                        Key: object.Key
                      };
                    })
                  }
                }).promise());

              case 1:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function deleteObjects(_x5) {
        return _deleteObjects.apply(this, arguments);
      }

      return deleteObjects;
    }()
  }, {
    key: "deletePaths",
    value: function () {
      var _deletePaths = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee5(paths) {
        var objects;
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                objects = paths.map(function (path) {
                  return {
                    Key: path
                  };
                });
                return _context5.abrupt("return", this.deleteObjects(objects));

              case 2:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function deletePaths(_x6) {
        return _deletePaths.apply(this, arguments);
      }

      return deletePaths;
    }()
  }, {
    key: "deleteFile",
    value: function () {
      var _deleteFile = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee6(path) {
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt("return", this.deleteObjects([{
                  Key: path
                }]));

              case 1:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function deleteFile(_x7) {
        return _deleteFile.apply(this, arguments);
      }

      return deleteFile;
    }()
  }, {
    key: "deleteFolder",
    value: function () {
      var _deleteFolder = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee7(folderPath) {
        var objects;
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this.listPathObjects(folderPath);

              case 2:
                objects = _context7.sent;
                return _context7.abrupt("return", this.deleteObjects(objects));

              case 4:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function deleteFolder(_x8) {
        return _deleteFolder.apply(this, arguments);
      }

      return deleteFolder;
    }()
  }, {
    key: "downloadFile",
    value: function () {
      var _downloadFile = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee8(filePathToRead, filePathToSave) {
        var _this2 = this;

        var createDirIfNotExists,
            parentPath,
            _args8 = arguments;
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                createDirIfNotExists = _args8.length > 2 && _args8[2] !== undefined ? _args8[2] : true;

                if (!createDirIfNotExists) {
                  _context8.next = 5;
                  break;
                }

                parentPath = _path["default"].dirname(filePathToSave);
                _context8.next = 5;
                return _fs["default"].promises.mkdir(parentPath, {
                  recursive: true
                });

              case 5:
                return _context8.abrupt("return", new Promise(function (resolve, reject) {
                  var fileWriteStream = _fs["default"].createWriteStream(filePathToSave);

                  _this2.s3client.getObject({
                    Bucket: _this2.bucket,
                    Key: filePathToRead
                  }).on('error', function (error) {
                    _fs["default"].unlinkSync(filePathToSave);

                    reject(error);
                  }).createReadStream().pipe(fileWriteStream);

                  fileWriteStream.on('finish', function () {
                    resolve(filePathToSave);
                  });
                }));

              case 6:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8);
      }));

      function downloadFile(_x9, _x10) {
        return _downloadFile.apply(this, arguments);
      }

      return downloadFile;
    }()
  }]);
  return SpacesClient;
}();

var _default = SpacesClient;
exports["default"] = _default;
module.exports = exports.default;